/*
 *		MACHINS
 *	premier jet le 19 octobre 2022, rue Ernest Renan
 *
 */
/*    ======================================================    */
/* new: Sat Jan 27 22:15:11 UTC 2024
 */
#declare Support_WMP = object
{
difference {
	box { <-2,   -1, -0.2>, <2,   2,   0.2> }
	box { <-1.9, -1, -0.6>, <1.9, 1.9, 0.6> }
	}
texture { MON_VERT_INDUS }
}

#declare Base_WMP = object
{
box { <-2.3, 0, -0.5>, <2.3, 0.25, 0.5> }
texture { TEINTE_BASIQUE scale 0.5 }
}

#declare Logo_WMP = object
{
union	{
	object	{
		Letters_WMP  pigment { color Orange }
		scale <0.95, 1, 1>
		translate <0.1, 0.50, 0>
		}
	object { Support_WMP }
	object { Base_WMP }
	}
}

/*    ======================================================    */

#local Truc_Mecanisme = object
{
#local D = 0.30;
#local C = D - 0.05;
#local E = D + 0.20;		// bout des tubes découpeurs
#local G = D * 0.30;		// rayon des tubes découpeurs

difference {
	union {
		box { <-D, -D, -D>, <D, D, D>  }
		cylinder { <-C, -E, -C>, <-C,  E, -C>, G }
		sphere { <-C, -E, -C>, G }
		sphere { <-C,  E, -C>, G }
		cylinder { < C, -E, -C>, < C,  E, -C>, G }
		sphere { < C, -E, -C>, G }
		sphere { < C,  E, -C>, G }
		cylinder { <-C, -E,  C>, <-C,  E,  C>, G }
		sphere { <-C, -E,  C>, G } 
		sphere { <-C,  E,  C>, G } 
		cylinder { < C, -E,  C>, < C,  E,  C>, G }
		sphere { < C, -E,  C>, G }
		sphere { < C,  E,  C>, G }
		}
	cylinder { < 0, -E,  0>, < 0,  E,  0>, G*1.717 }
	}

texture { TURQ_BOZO scale 2.75 }
rotate <clock * 2 * NormClock, clock*2, clock*3*NormClock>
}

#local Spot_meca_corps = object
{
union	{
	difference {
		cylinder { <0, 0, 0>,    <0, 0.25, 0>, 0.11 }
		cylinder { <0, 0.01, 0>, <0, 0.31, 0>, 0.10 }
		texture { GRIS_BROTCH scale 0.40 }
		}
	difference {
		cylinder { <0, 0.010, 0>, <0, 0.245, 0>, 0.10 }
		cylinder { <0, 0.011, 0>, <0, 0.31, 0>, 0.09 }
		texture  { pigment { color White }
			finish { ambient 0.47 phong 0.62 metallic 0.50 }
			}
		}
	// cylinder { <0, 0, -0.09>,    <0, 1.30, 0>, 0.012 }
	}
}

#local Spot_meca = object
{
union	{
	object { Spot_meca_corps }
	light_source { <0, 0.04, 0> ,
		color Gray10
		fade_distance   (FADE_D)
		fade_power      (FADE_P)
		}
	}
rotate x*33
}

#local Les_4_spots = object
{
#local ES = 0.72;

union	{
	object { Spot_meca rotate  y*45  translate <-ES, 0, -ES> }
	object { Spot_meca rotate -y*48  translate < ES, 0, -ES> }
	object { Spot_meca rotate  y*135 translate <-ES, 0,  ES> }
	object { Spot_meca rotate -y*132 translate < ES, 0,  ES> }
	}
}

#local Base_cadre = object
{
#local B_b_2 = D_base - 0.07;
difference {
	box { <-D_base, 0, -D_base>, <D_base, H_base-0.05, D_base> }
	box { <-B_b_2, 0.16, -B_b_2>, <B_b_2, H_base+1, B_b_2> }
	}
texture { MON_ROUGE_INDUS scale 0.75 }
}

#local Base_Mecanisme = object
{
union	{
	object { Base_cadre }
	object { Les_4_spots translate y*0.30 }
	}
}

#declare Le_Mecanisme = object
{
union {
	object { Base_Mecanisme				 }
	object { Truc_Mecanisme		translate y*1.61 }
	}
}

/*    ======================================================    */

#local R_hep  = 0.666;
#local HA_hep = 0.55;
#local HB_hep = 0.90;

#declare Heptacle_0_base = object
{
box { <-0.49, 0, -0.49>, <0.49, 0.034, 0.49> }
texture { T_Wood31 scale 1.5 rotate z*33 }
}

#declare Heptacle_0_axe = object
{
merge	{
	cylinder { 0, <0, 1.25, 0>, 0.02 }
	cone     { <0, 0.09, 0>, 0.22, <0, 0.14, 0>, 0.019999 }
	cylinder { 0, <0, 0.09, 0>, 0.22 }

	#local Off = 0.011;
	#local Ha  = HA_hep + Off;
	#local Hb  = HB_hep + Off;
	cylinder { <0, -0.04, 0>, <0, 0.01, 0>, 0.040   translate Ha*y }
	cylinder { <0, -0.04, 0>, <0, 0.01, 0>, 0.040   translate Hb*y }

	sphere { 0, 0.045 scale <1, 1.9, 1> translate y*1.25 }
	}
texture { TURQ_BOZO scale 4.4444 }
}

#declare Heptacle_0_B = object
{
#local RB =  0.053;
#local SY =  0.400;
merge	{
	#for (foo, 0, 360, 360/7)
	  #local dx = R_hep * sin(radians(foo));
	  #local dz = R_hep * cos(radians(foo));
	  sphere { 0, RB scale  <1, SY, 1> translate <dx, 0.05, dz> }
	  cylinder { <0, -0.05, 0>, <0, 0.05, 0>, RB translate <dx, 0, dz> }
	  sphere { 0, RB scale  <1, SY, 1> translate <dx, -0.05, dz> }
	  // 
	#end
	texture {  T_Copper_3D scale 2.2222 }
	}
}

#declare Heptacle_0_haubans = object
{
merge	{
	#for (foo, 0, 360, 360/7)
	 #local dx = R_hep * sin(radians(foo));
	 #local dz = R_hep * cos(radians(foo));
	 #local dy = -0.12;
	 cylinder { <dx, dy, dz>, <dx*0.05, 0, dz*0.05>, 0.011 }
	 sphere   { <dx, dy, dz>, 0.021 }
	#end
	texture { ROSE_BIZARRE scale 2.0 }
	}
}

#declare Un_Heptacle = object
{
union	{
	object { Heptacle_0_B translate -0.20*y }
	object { Heptacle_0_haubans }
	}
}

#declare Heptacles = object
{
union	{
	object { Heptacle_0_axe }
	object { Heptacle_0_base }
	#local Ck = clock*3.141592654;
	object { Un_Heptacle rotate -y*Ck translate HA_hep*y }
	object { Un_Heptacle rotate  y*Ck translate HB_hep*y }
	}
}

#declare Les_Heptacles = object
{
union {
	object { Base_Machins }
	object { Heptacles translate y*H_base }
	}
}

/*    ======================================================    */
